// Задача "Великий Флатландскитй Забор"
// 4-я личная Интернет-олимпиада сезона 2009/2010
// Автор задачи: Федор Царев, fedor.tsarev@gmail.com
// Автор решения: Максим Носенко, nosenkomax@gmail.com
// Неверное решение - переполнение

import java.util.*;
import java.io.*;
import static java.lang.Math.*;

public class greatwall_mn_wrong implements Runnable {

	public static void main(String args[]) {
		new Thread(new greatwall_mn_wrong()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "greatwall";
	boolean eof = false;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}
	
	class Segment implements Comparable<Segment>{
		int x1, y1, x2, y2;
		double len;
		
		public Segment(int a, int b, int c, int d) {
			if (ok(a, b, c, d)) {
				x1 = a;
				y1 = b;
				x2 = c;
				y2 = d;
			} else {
				x2 = a;
				y2 = b;
				x1 = c;
				y1 = d;
			}
			len =  sqrt((a - c)* (a - c) + (b - d) * (b - d));
		}
		
		@Override
		public int compareTo(Segment o) {
			if (x1 != o.x1)
				return x1 < o.x1 ? -1 : 1;
			if (y1 != o.y1)
				return y1 < o.y1 ? -1 : 1;
			if (x2 != o.x2)
				return x2 < o.x2 ? -1 : 1;
			if (y2 != o.y2)
				return y2 < o.y2 ? -1 : 1;
			return 0;
		}
	}
	
	TreeSet<Segment> ts;
	double ans;

	private void solve() {
		int n = nextInt();
		ts = new TreeSet<Segment>();
		
		int x1, y1, x2, y2, x3, y3;
		Segment a, b, c;
		
		ans = 0;
		
		for (int i = 0; i < n; i++) {
			x1 = nextInt();
			y1 = nextInt();
			x2 = nextInt();
			y2 = nextInt();
			x3 = nextInt();
			y3 = nextInt();
			a = new Segment(x1, y1, x2, y2);
			b = new Segment(x1, y1, x3, y3);
			c = new Segment(x3, y3, x2, y2);
			
			add(a);
			add(b);
			add(c);
		}
		
		out.printf("%.4f", ans);
		
		
	
		
	}

	private void add(Segment a) {
		if (!ts.contains(a)) {
			ts.add(a);
			ans += a.len;
		} else {
			ans -= a.len;
		}
		
	}

	public boolean ok(int a, int b, int c, int d) {
		if (a != c)
			return a < c;
		return b < d;
	}
}
